﻿using SocialFeed.Common;
using SocialFeed.Data;
using SocialFeed.EnableLiveTile;
using SocialFeed.SettingsFlyouts;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.ApplicationSettings;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Animation;
using Windows.UI.Xaml.Navigation;

// The Grouped Items Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234231

namespace SocialFeed
{
    /// <summary>
    /// A page that displays a grouped collection of items.
    /// </summary>
    public sealed partial class HubPage : SocialFeed.Common.LayoutAwarePage
    {
        Popup pop = new Popup();
        public HubPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Populates the page with content passed during navigation.  Any saved state is also
        /// provided when recreating a page from a prior session.
        /// </summary>
        /// <param name="navigationParameter">The parameter value passed to
        /// <see cref="Frame.Navigate(Type, Object)"/> when this page was initially requested.
        /// </param>
        /// <param name="pageState">A dictionary of state preserved by this page during an earlier
        /// session.  This will be null the first time a page is visited.</param>
        protected override void LoadState(Object navigationParameter, Dictionary<String, Object> pageState)
        {
            var HubPageDataGroups = HubPageDataSource.GetGroups((String)navigationParameter);
            this.DefaultViewModel["Groups"] = HubPageDataGroups;

            var RecentDataGroups = RecentDataSource.GetGroups((String)navigationParameter);
            this.DefaultViewModel["Groups2"] = RecentDataGroups;
            CreateLiveTile.ShowliveTile(false, "Social Feed");
        }

        private void Submit_Clicked(object sender, RoutedEventArgs e)
        {
            settingsPopup = new Popup();
            Rect windowsBounds = Window.Current.Bounds;
            settingsPopup.Closed += settingsPopup_Closed;
            Window.Current.Activated += Current_Activated;

            settingsPopup.IsLightDismissEnabled = true;
            settingsPopup.Height = windowsBounds.Height;
            settingsPopup.Width = windowsBounds.Width;

            PostedNotification travelQueryFlyout = new PostedNotification();
           travelQueryFlyout.Height = windowsBounds.Height;
           travelQueryFlyout.Width = windowsBounds.Width; 
            settingsPopup.Child = travelQueryFlyout;
            settingsPopup.VerticalAlignment = VerticalAlignment.Center;
            settingsPopup.HorizontalAlignment = HorizontalAlignment.Center;

            settingsPopup.ChildTransitions = new Windows.UI.Xaml.Media.Animation.TransitionCollection() { new Windows.UI.Xaml.Media.Animation.PopupThemeTransition() { FromVerticalOffset = 500 } };

            
            

           

            settingsPopup.IsOpen = true;
            
        }

        private void Header_Clicked(object sender, RoutedEventArgs e)
        {
            if (e == null)
                return;
            if (e.OriginalSource == null)
                return;
            Button Social = new Button();
            if (e.OriginalSource is Button)
                Social = e.OriginalSource as Button;

            if (Social.Tag == "Group-1")
                FaceBookPopup();

            if (Social.Tag == "Group-2")
                Twitter();

            if (Social.Tag == "Group-3")
                LinkedIn();
        }

        private void itemGridView_ItemClick_1(object sender, ItemClickEventArgs e)
        {
            if (e == null)
                return;
            HubPageDataItem data = null;
            data = e.ClickedItem as HubPageDataItem;
            if (data != null && data.UniqueId.StartsWith("Group-1"))
                FaceBookPopup();
            if (data != null && data.UniqueId.StartsWith("Group-2"))
                Twitter();
            if (data != null && data.UniqueId.StartsWith("Group-3"))
                LinkedIn();
        }

        public static Popup settingsPopup = null;
        void Current_Activated(object sender, Windows.UI.Core.WindowActivatedEventArgs e)
        {
            if (e.WindowActivationState == Windows.UI.Core.CoreWindowActivationState.Deactivated)
            {
                settingsPopup.IsOpen = false;
            }
        }

        void settingsPopup_Closed(object sender, object e)
        {
            Window.Current.Activated -= Current_Activated;
        }

        private void FaceBookPopup()
        {
            settingsPopup = new Popup();
            Rect windowsBounds = Window.Current.Bounds;
            settingsPopup.Closed += settingsPopup_Closed;
            Window.Current.Activated += Current_Activated;

            settingsPopup.IsLightDismissEnabled = true;
            settingsPopup.Height = windowsBounds.Height;
            FaceBook filter = new FaceBook();

            filter.Height = windowsBounds.Height;

            settingsPopup.Child = filter;
            settingsPopup.SetValue(Canvas.LeftProperty, windowsBounds.Width - 360);
            settingsPopup.SetValue(Canvas.TopProperty, 0);
            settingsPopup.IsOpen = true;
            settingsPopup.ChildTransitions = new TransitionCollection();
            settingsPopup.ChildTransitions.Add(new EdgeUIThemeTransition()
            {
                Edge = (SettingsPane.Edge == SettingsEdgeLocation.Right) ?
                       EdgeTransitionLocation.Right :
                       EdgeTransitionLocation.Left
            });
        }

        private void LinkedIn()
        {
            settingsPopup = new Popup();
            Rect windowsBounds = Window.Current.Bounds;
            settingsPopup.Closed += settingsPopup_Closed;
            Window.Current.Activated += Current_Activated;

            settingsPopup.IsLightDismissEnabled = true;
            settingsPopup.Height = windowsBounds.Height;
            LinkedIn filter = new LinkedIn();

            filter.Height = windowsBounds.Height;

            settingsPopup.Child = filter;
            settingsPopup.SetValue(Canvas.LeftProperty, windowsBounds.Width - 360);
            settingsPopup.SetValue(Canvas.TopProperty, 0);
            settingsPopup.IsOpen = true;
            settingsPopup.ChildTransitions = new TransitionCollection();
            settingsPopup.ChildTransitions.Add(new EdgeUIThemeTransition()
            {
                Edge = (SettingsPane.Edge == SettingsEdgeLocation.Right) ?
                       EdgeTransitionLocation.Right :
                       EdgeTransitionLocation.Left
            });
        }

        private void Twitter()
        {
            settingsPopup = new Popup();
            Rect windowsBounds = Window.Current.Bounds;
            settingsPopup.Closed += settingsPopup_Closed;
            Window.Current.Activated += Current_Activated;

            settingsPopup.IsLightDismissEnabled = true;
            settingsPopup.Height = windowsBounds.Height;
            Twitter filter = new Twitter();

            filter.Height = windowsBounds.Height;

            settingsPopup.Child = filter;
            settingsPopup.SetValue(Canvas.LeftProperty, windowsBounds.Width - 360);
            settingsPopup.SetValue(Canvas.TopProperty, 0);
            settingsPopup.IsOpen = true;
            settingsPopup.ChildTransitions = new TransitionCollection();
            settingsPopup.ChildTransitions.Add(new EdgeUIThemeTransition()
            {
                Edge = (SettingsPane.Edge == SettingsEdgeLocation.Right) ?
                       EdgeTransitionLocation.Right :
                       EdgeTransitionLocation.Left
            });
        }

      
    }
}
